#!/usr/bin/env python
'''
Copyright (C) 2008 Stephane de la Linuxerie - http://polariscorp.free.fr  -  http://linuxerie.midiblogs.com

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'''

import random
import pygame
import glob
import os
import re
import sys
import datetime
import Image
from pygame.locals import FULLSCREEN, KEYDOWN, QUIT, K_ESCAPE, K_SPACE, K_RIGHT, K_LEFT, K_UP, K_DOWN, MOUSEBUTTONDOWN, MOUSEMOTION, K_KP_PLUS, K_KP_MINUS, KMOD_CTRL, K_s, K_e

X = 0
POS_X = 0
OLD_POS = 0
SIZE_MAX = 50
HOME = os.getenv("HOME")
HEIGHT_SCREEN = 768
WIDTH_SCREEN = 1024

TABLEAU_FOND = glob.glob(os.path.join('fonds','*.jpg'))
TABLEAU_FOND_PERSO = glob.glob(os.path.join(HOME, 'mes_grabouilles', 'fonds','*.jpg'))

TABLEAU_FOND.extend(TABLEAU_FOND_PERSO)

MUSIQUE = glob.glob(os.path.join(HOME, 'mes_grabouilles', 'musiques','*.mp3'))

REPERTOIRE_IMAGES = 'images'
CURRENT_IMAGES = ''
FR = 'fr1.png', 'fr2.png', 'fr3.png', 'fr3.png'
TRACE_LISTE_CARTE = 'etoile', 'maison', 'bateau', 'sapin'
THEME = 'etoile.png', 'coeur.png', 'cox.png'
THEME_FILLE = 'etoile.png', 'coeur.png', 'cox.png'
THEME_GARCON = 'bomb.png', 'eprouvette.png', 'loup.png'

class fond_ecran :
	def change(self):
		global background,CURRENT_IMAGES

		CURRENT_IMAGES = random.choice(TABLEAU_FOND)
		background = pygame.image.load(CURRENT_IMAGES).convert()
		background = pygame.transform.scale(background, (WIDTH_SCREEN, HEIGHT_SCREEN))

		for x in range(10):
			background_old = pygame.image.load(CURRENT_IMAGES).convert()
			background_old = pygame.transform.scale(background_old, (WIDTH_SCREEN, HEIGHT_SCREEN))
			background_old.set_alpha((x * 255) / 10.0, pygame.RLEACCEL)
			screen.blit(background_old, (0,0))
			pygame.display.update()	
		
		screen.blit(background, (0,0))
		pygame.display.update()
		
	def efface(self):	
		global background,CURRENT_IMAGES
		background = pygame.image.load(CURRENT_IMAGES).convert()
		background = pygame.transform.scale(background, (WIDTH_SCREEN, HEIGHT_SCREEN))
		screen.blit(background, (0,0))
		pygame.display.update()
		
class musique :
	def __init__(self):
		pygame.mixer.init() 
		
	def joue_musique(self):
		try:
			choix_aleatoire_musique = random.choice(MUSIQUE)
			pygame.mixer.music.load(choix_aleatoire_musique)
			pygame.mixer.music.play()
		except:
				pass	
				
class son :
	def joue_son(self, sons):
		sound = pygame.mixer.Sound(sons)
		if pygame.mixer.get_busy():
			return()
		else:
			try:
				sound.set_volume(1)
				sound.play()
			except:
				pass
			
class sauvegarde:
	def __init__(self):
		dte =  datetime.datetime.now()
		dte = dte.strftime("%d-%m-%y_%H-%M-%S")
		tar_img = os.path.join(HOME, 'mes_grabouilles', 'image_du-'+ str(dte) +'.bmp')
		if os.path.isdir(os.path.join(HOME, 'mes_grabouilles')) :
			try:
				pygame.image.save(screen, tar_img)
				Image.open(os.path.join(HOME, 'mes_grabouilles', 'image_du-'+ str(dte) +'.bmp')).save(os.path.join(HOME, 'mes_grabouilles', 'image_du-'+ str(dte) +'.jpg'))
				os.remove(os.path.join(HOME, 'mes_grabouilles', 'image_du-'+ str(dte) +'.bmp'))
			except:
				pass
		self.confirmation()
		
	def confirmation(self):
		vignette_sav = pygame.image.load(os.path.join('images', 'sauvegarde.png')).convert_alpha() 
		terrain_en_cours = screen.copy()
		print 'ok'
		screen.blit(terrain_en_cours, (0,0))
		screen.blit(vignette_sav, (280,250))
		pygame.display.update()
		pygame.time.wait(2000)
		screen.blit(terrain_en_cours, (0,0))
		pygame.display.update()		

						
class couleur_aleatoire:
	def couleur(self):
		col1 = random.randrange(0, 255)
		col2 = random.randrange(0, 255)
		col3 = random.randrange(0, 255)
		return (col1, col2, col3)

class attrape :
	def __init__(self):
		fond_ecran().change()
		self.bg = pygame.image.load(CURRENT_IMAGES).convert() 
		pygame.mouse.set_visible(0)
		self.boucle_attrape()
		
	def ecri_texte(self, texte, color, pos, size):
		font_chx = pygame.font.Font(os.path.join(REPERTOIRE_IMAGES, 'Cookies.ttf'), size)
		text_fil = font_chx.render(texte, True, color, )
		screen.blit(text_fil, pos)
		pygame.display.update()
				
	def boucle_attrape (self):	
		trouve = 'non'
		size_reg = 10
		size_obj = random.randrange(20, 100)
		x_obj = random.randrange(50, 950)-size_obj
		y_obj = random.randrange(50, 720)-size_obj 
		current = random.choice(FR)
		img_attrape = os.path.join('images', current)
		image_attrape_ok = pygame.image.load(img_attrape).convert_alpha()
		image_attrape_ok = pygame.transform.scale(image_attrape_ok, (size_obj, size_obj))
		screen.blit(image_attrape_ok, (x_obj, y_obj))	
		pygame.display.update()
		terrain_en_cours = screen.copy()
		
		while trouve != 'oui':
			mods = pygame.key.get_mods()
			objet_a_trouver = pygame.Rect(x_obj, y_obj, size_obj, size_obj)
			
			if objet_a_trouver.collidepoint(pygame.mouse.get_pos()) :
				son().joue_son(os.path.join('sons', 'tada.ogg'))
				fleur = pygame.image.load(os.path.join('images','fleur.png')).convert_alpha()
				ancien_terrain = screen.copy()
				
				while size_reg < 500:
					size_reg += 20
					fleur_alpha = pygame.transform.scale(fleur, (size_reg, size_reg))
				
					screen.blit(ancien_terrain, (0, 0))
					screen.blit(fleur_alpha, (180, 100))
					pygame.display.update()
					pygame.time.wait(50)
					
				self.ecri_texte('BRAVO !', (0, 0, 0), (90, 250), 260)
				self.ecri_texte('BRAVO !', (255, 255, 255), (100, 250), 250)				
				pygame.display.update()
				pygame.time.wait(1500)
				trouve = 'oui'
			
			for  event in pygame.event.get():
				if event.type == QUIT:
						exit()	
				elif event.type == MOUSEMOTION:
					x, y = pygame.mouse.get_pos()
					curseur_attrape = pygame.image.load(os.path.join('images','etoile.png')).convert_alpha()
					x -= curseur_attrape.get_width()/2
					y -= curseur_attrape.get_height()/2
					screen.blit(terrain_en_cours, (0, 0))
					screen.blit(curseur_attrape, (x, y))
					pygame.display.update()
				elif event.type == KEYDOWN:	
					if event.key == K_SPACE :
						attrape()
					elif (event.key == K_e and mods & KMOD_CTRL):
						intro()				
		attrape()
		
class trace :
	def __init__(self):
		fond_ecran().change()
		musique().joue_musique()
		pygame.mouse.set_visible(1)
		self.boucle_trace()
		
	def ecri_texte(self, texte, color, pos, size):
		pygame.draw.rect(screen, (20, 20, 20), (845, 625, 300, 150), 0)
		pygame.draw.rect(screen, (213, 213, 213), (850, 630, 300, 150), 0)
		font_chx = pygame.font.Font(os.path.join(REPERTOIRE_IMAGES, 'Cookies.ttf'), size)
		text_fil = font_chx.render(texte, True, color, )
		screen.blit(text_fil, pos)
		pygame.display.update()
				
	def patiente(self):
		pygame.time.wait(500)
		pygame.display.update()
			
	def trace_point_aleatoire(self):
		point = pygame.image.load(os.path.join('images','point.png')).convert_alpha()
		
		choix = random.choice(TRACE_LISTE_CARTE)
		
		if choix == 'etoile':
				screen.blit(point, (470, 120))
				self.patiente()
				screen.blit(point, (432, 263))
				self.patiente()
				screen.blit(point, (220, 260))
				self.patiente()
				screen.blit(point, (400, 380))
				self.patiente()
				screen.blit(point, (310, 630))
				self.patiente()
				screen.blit(point, (490, 450))
				self.patiente()
				screen.blit(point, (620, 636))
				self.patiente()
				screen.blit(point, (600, 390))
				self.patiente()
				screen.blit(point, (700, 275))
				self.patiente()
				screen.blit(point, (526, 265))
				self.patiente()
				nb_points = 10
		if choix == 'maison':	
				screen.blit(point, (476, 88))
				self.patiente()
				screen.blit(point, (280, 298))
				self.patiente()
				screen.blit(point, (280, 696))
				self.patiente()
				screen.blit(point, (698, 696))
				self.patiente()
				screen.blit(point, (710, 329))
				self.patiente()
				screen.blit(point, (650, 230))
				self.patiente()
				screen.blit(point, (650, 146))
				self.patiente()
				screen.blit(point, (600, 146))
				self.patiente()
				screen.blit(point, (600, 196))
				self.patiente()
				nb_points = 9
		if choix == 'bateau':	
				screen.blit(point, (460, 450))
				self.patiente()
				screen.blit(point, (760, 450))
				self.patiente()
				screen.blit(point, (460, 60))
				self.patiente()
				screen.blit(point, (460, 500))
				self.patiente()
				screen.blit(point, (150, 500))
				self.patiente()
				screen.blit(point, (250, 675))
				self.patiente()
				screen.blit(point, (630, 675))
				self.patiente()
				screen.blit(point, (800, 500))
				self.patiente()
				nb_points = 8
		if choix == 'sapin':	
				screen.blit(point, (471, 40))
				self.patiente()
				screen.blit(point, (290, 200))
				self.patiente()
				screen.blit(point, (400, 200))
				self.patiente()
				screen.blit(point, (288, 315))
				self.patiente()
				screen.blit(point, (450, 350))
				self.patiente()
				screen.blit(point, (100, 500))
				self.patiente()
				screen.blit(point, (450, 500))
				self.patiente()
				screen.blit(point, (450, 660))
				self.patiente()
				screen.blit(point, (550, 660))
				self.patiente()
				screen.blit(point, (550, 500))
				self.patiente()
				screen.blit(point, (900, 520))
				self.patiente()
				screen.blit(point, (580, 320))
				self.patiente()
				screen.blit(point, (820, 312))
				self.patiente()
				screen.blit(point, (580, 200))
				self.patiente()
				screen.blit(point, (730, 200))
				self.patiente()
				nb_points = 15
		
		return nb_points

	def boucle_trace (self):
		
		choix = self.trace_point_aleatoire()
		countdown = 0
		trace_count_not_over = 1
		points = []
		
		while trace_count_not_over :	
			countdown += 0.009
			font = pygame.font.Font(os.path.join(REPERTOIRE_IMAGES, 'SMARC___.TTF'), 60)
			count_str = int(countdown)
			self.ecri_texte(str(count_str), (0, 0, 0), (870, 650), 100)
			
			if count_str == 60 :
				trace_count_not_over = 0
				trace()
			
			mods = pygame.key.get_mods()
			for  event in pygame.event.get():
				if event.type == QUIT:
						exit()
				elif event.type == MOUSEMOTION:
					retour_click = pygame.mouse.get_pressed()
					size = random.randrange(0, 20)	
					x, y = pygame.mouse.get_pos()
					if retour_click[0]:
						pygame.draw.circle(screen, couleur_aleatoire().couleur(), (x, y), size, 0)	
						pygame.display.update()	
				#elif event.type == MOUSEBUTTONDOWN:
				#	points.append(event.pos)
				#	if len(points) > choix-1:
				#		pygame.draw.polygon(screen,(0, 255, 255), points)
				#		pygame.display.update()
				#		pygame.time.wait(1500)
				#		trace()
							
				elif event.type == KEYDOWN:	
					if event.key == K_SPACE :
						trace()
					elif (event.key == K_e and mods & KMOD_CTRL):
						intro()																			
class grabouille :
	def __init__(self):
		fond_ecran().change()
		musique().joue_musique()
		pygame.mouse.set_visible(1)
		self.boucle_grabouille()
		
	def boutton_cliquer(self, btn, x, y):
		CLIC_MILIEU = 'vide1.png', 'vide1.png', THEME[0] , 'vide1.png', 'vide1.png', 'vide1.png',  THEME[1], 'vide1.png', 'vide1.png', 'vide1.png'
		CLIC_DROIT = 'vide1.png',  THEME[2], 'vide1.png', 'vide1.png', 'vide1.png', 'vide1.png', 'vide1.png', 'vide1.png'

		size_coeur_etoile = random.randrange(0, 60) 
		pos = x, y
		nb_zoom = random.random()*1.2
		angle_rot = random.randrange(0, 360) 
		img_x_pos = random.randrange(-15, 15)
		img_y_pos = random.randrange(-15, 15)
		
		img_background = os.path.join(REPERTOIRE_IMAGES, random.choice(CLIC_MILIEU))
		image_alpha = pygame.image.load(img_background).convert_alpha()
		img_background_cox = os.path.join(REPERTOIRE_IMAGES, random.choice(CLIC_DROIT))
		image_alpha_cox = pygame.image.load(img_background_cox).convert_alpha()
		
		if btn == 0:
			son().joue_son(os.path.join('sons', 'rire.wav'))
		if btn == 1:
			image_alpha_cox = pygame.transform.rotozoom(image_alpha_cox, angle_rot, nb_zoom)
			screen.blit(image_alpha_cox, (pos[0]+img_x_pos, pos[1]+img_y_pos))
			pygame.display.update()
			son().joue_son(os.path.join('sons', 'oops.wav'))
		if btn == 2:
			image_alpha = pygame.transform.scale(image_alpha, (size_coeur_etoile, size_coeur_etoile))
			screen.blit(image_alpha, (pos[0]+img_x_pos, pos[1]+img_y_pos))
			pygame.display.update()
			son().joue_son(os.path.join('sons', 'rien.wav'))
		
	def boucle_grabouille (self):
		global SIZE_MAX, OLD_POS
		
		while 1:					
			mods = pygame.key.get_mods()
			for  event in pygame.event.get():
				if event.type == QUIT:
						exit()
						
				elif event.type == MOUSEMOTION:
					retour_click = pygame.mouse.get_pressed()
					size = random.randrange(0, SIZE_MAX)	
					x, y = pygame.mouse.get_pos()
					if retour_click[0]:
						self.boutton_cliquer(0, x, y)
					elif retour_click[1]:
						self.boutton_cliquer(1, x, y)
					elif retour_click[2]:
						self.boutton_cliquer(2, x, y)		
					else:		
						pygame.draw.circle(screen, couleur_aleatoire().couleur(), (x, y), size, 0)	
						pygame.display.update()
												
				elif event.type == KEYDOWN:	
					if event.key == K_LEFT or event.key == K_RIGHT or event.key == K_DOWN or event.key == K_UP :
						fond_ecran().change()
					elif event.key == K_SPACE :
						fond_ecran().efface()	
					elif event.key == K_KP_PLUS:	
						SIZE_MAX += 5
					elif event.key == K_KP_MINUS:	
						SIZE_MAX -= 5	
					elif (event.key == K_s and mods & KMOD_CTRL):
						sauvegarde()
					elif (event.key == K_e and mods & KMOD_CTRL):
						intro()
					else:
						valeur = pygame.key.name(event.key)
						regexp_touche_valide = re.compile('[a-z]')
						if valeur == 'left ctrl':
							pass		
						elif  regexp_touche_valide.match(valeur) :
							size_texte = random.randrange(200, 300)
							pos = pygame.mouse.get_pos()
							font = pygame.font.Font(os.path.join(REPERTOIRE_IMAGES, 'SMARC___.TTF'), size_texte)
							text = font.render(valeur, True, couleur_aleatoire().couleur(), )
							if pos[0] == OLD_POS :
								POS_X = POS_X + 100
							else :
								POS_X = pos[0]
							screen.blit(text, (POS_X-40,pos[1]-200))
							son().joue_son(os.path.join('sons', 'tape.wav'))
							OLD_POS = pos[0]
							pygame.display.update()	
						else:
							pass
							
class options_intro :
	def __init__(self):	
		options_retour = pygame.Rect(280, 680, 370, 90)
		background_option = pygame.image.load(os.path.join('images','options.jpg')).convert()
		screen.blit(background_option, (0,0))
		self.ecri_texte('Retour', (255, 255, 255), (450, 730), 36)
		self.ecri_texte('Clavier :', (209, 148, 12), (480, 200), 40)
		self.ecri_texte('Souris :', (209, 148, 12), (480, 360), 40)
		self.ecri_texte('Dossiers :', (209, 148, 12), (480, 460), 40)
		
		self.ecri_texte('CTRL + e : Sortir', (209, 148, 12), (480, 240), 20)
		self.ecri_texte('CTRL + s : Sauvegarder une image', (209, 148, 12), (480, 260), 20)
		self.ecri_texte('Espace : Nettoyer l\' ecran', (209, 148, 12), (480, 280), 20)
		self.ecri_texte('+ ou - : Change la taille du pinceau', (209, 148, 12), (480, 300), 20)
		self.ecri_texte('Clavier : Ecrire', (209, 148, 12), (480, 320), 20)
		
		self.ecri_texte('Clic gauche : Ne grabouille pas', (209, 148, 12), (480, 400), 20)
		self.ecri_texte('Clic milieu ou droite: Dessin aleatoire', (209, 148, 12), (480, 420), 20)
		
		self.ecri_texte('mes_grabouilles/fonds : les images', (209, 148, 12), (480, 500), 20)
		self.ecri_texte('mes_grabouilles/musiques : les musiques', (209, 148, 12), (480, 520), 20)

		pygame.display.update()
		while 1:
			souris_position = pygame.mouse.get_pos()
			for event in pygame.event.get():	
				if event.type == QUIT:
					sys.exit(1)
				elif options_retour.collidepoint(souris_position) :
					btn = pygame.mouse.get_pressed()
					if btn[0] == True:
						intro()	
													
	def ecri_texte(self, texte, color, pos, size):
		font_chx = pygame.font.Font(os.path.join(REPERTOIRE_IMAGES, 'Cookies.ttf'), size)
		text_fil = font_chx.render(texte, True, color, )
		screen.blit(text_fil, pos)
		pygame.display.update()
								
class intro :
	def __init__(self):
		global THEME
		pygame.mouse.set_visible(1)
		pygame.mixer.stop()
		pygame.mixer.music.stop()
		background_intro = pygame.image.load(os.path.join('images','grabouille.jpg')).convert()
		son().joue_son(os.path.join('sons', 'intro.ogg'))
		screen.blit(background_intro, (0,0))	

		choix3 = pygame.Rect(220, 550, 545, 130)
		choix1 = pygame.Rect(220, 220, 545, 130)
		choix2 = pygame.Rect(220, 411, 545, 130)
		grabouilleuse = pygame.Rect(495, 150, 220, 32)
		grabouilleur = pygame.Rect(210, 150, 207, 32)
		quitter = pygame.Rect(250, 730, 200, 36)
		options = pygame.Rect(500, 730, 200, 36)

		self.ecri_texte_zoom ('Grabouiller', (255, 255, 255), (270, 280), 80)
		self.ecri_texte_zoom ('Attraper', (255, 255, 255), (310, 430), 80)
		self.ecri_texte_zoom ('Tracer', (255, 255, 255), (350, 590), 80)
		
		self.ecri_texte ('Quitter', (255, 255, 255), (340, 730), 30)
		self.ecri_texte ('Options', (255, 255, 255), (540, 730), 30)

		ecran_acc = screen.copy()
		
		self.ecri_texte ('Grabouilleur', (255, 255, 255), (220, 150), 30)
		self.ecri_texte ('Grabouilleuse', (255, 255, 255), (520, 150), 30)
		pygame.display.update()		
		
	
		while 1:
			souris_position = pygame.mouse.get_pos()
			for event in pygame.event.get():
				btn = pygame.mouse.get_pressed()
				if event.type == QUIT:
					exit()
				elif quitter.collidepoint(souris_position) :
					if btn[0] == True:
						exit()
				elif choix3.collidepoint(souris_position) :
					if btn[0] == True:
						pygame.mixer.stop()
						trace()
				elif choix2.collidepoint(souris_position) :
					if btn[0] == True:
						pygame.mixer.stop()
						attrape()						
				elif choix1.collidepoint(souris_position) :
					if btn[0] == True:
						pygame.mixer.stop()
						grabouille()
				elif grabouilleuse.collidepoint(souris_position) :
					if btn[0] == True:
						screen.blit(ecran_acc, (0, 0))
						self.ecri_texte ('Grabouilleur', (255, 255, 255), (220, 150), 30)
						self.ecri_texte ('Grabouilleuse', (255, 143, 143), (520, 150), 30)
						girl_option = pygame.image.load(os.path.join('images','girl.png')).convert_alpha()
						screen.blit(girl_option, (760,160))
						pygame.display.update()		
						THEME = THEME_FILLE
				elif options.collidepoint(souris_position) :		
					if btn[0] == True:
						options_intro()			
				elif grabouilleur.collidepoint(souris_position) :
					if btn[0] == True:
						screen.blit(ecran_acc, (0, 0))
						self.ecri_texte ('Grabouilleur', (0, 138, 234), (220, 150), 30)
						self.ecri_texte ('Grabouilleuse', (255, 255, 255), (520, 150), 30)
						girl_option = pygame.image.load(os.path.join('images','boy.png')).convert_alpha()
						screen.blit(girl_option, (20,160))
						pygame.display.update()		
						THEME = THEME_GARCON
									
	def ecri_texte(self, texte, color, pos, size):
		font_chx = pygame.font.Font(os.path.join(REPERTOIRE_IMAGES, 'Cookies.ttf'), size)
		text_fil = font_chx.render(texte, True, color, )
		screen.blit(text_fil, pos)
		pygame.display.update()

	def ecri_texte_zoom(self, texte, color, pos, size):
		text_size = 0
		background_intro = pygame.image.load(os.path.join('images','grabouille.jpg')).convert()
		terrain_en_cours = screen.copy()
		
		while text_size < size:
			text_size += 1
			font_chx = pygame.font.Font(os.path.join(REPERTOIRE_IMAGES, 'Cookies.ttf'), text_size)
			text_fil = font_chx.render(texte, True, color, )
			screen.blit(terrain_en_cours, (0,0))
			screen.blit(text_fil, pos)
			pygame.display.update()				
						
if __name__ == '__main__' : 
	if os.path.isdir(os.path.join(HOME, 'mes_grabouilles')) == False :
		os.mkdir(os.path.join(HOME, 'mes_grabouilles'))
		
	if os.path.isdir(os.path.join(HOME, 'mes_grabouilles','musiques')) == False :
		os.mkdir(os.path.join(HOME, 'mes_grabouilles', 'musiques'))
		
	if os.path.isdir(os.path.join(HOME, 'mes_grabouilles','fonds')) == False :
		os.mkdir(os.path.join(HOME, 'mes_grabouilles', 'fonds'))
						
	pygame.mixer.pre_init(44100, -16, 2, 1024) 
	pygame.init()
	#screen = pygame.display.set_mode((1024,768), 0, 32)
	screen = pygame.display.set_mode((1024, 768), FULLSCREEN)	
	pygame.display.set_caption("Grabouille")	
	intro() 
